import React from 'react'
import hoistNonReactStatics from 'hoist-non-react-statics'

const Context = React.createContext({})
export default Context

export const HoverContext = React.createContext({})

export const Connect = Consumer => (subscribe, options) => Comp => {
  const subscriber = typeof subscribe({}) === 'function' ? subscribe() : subscribe
  class Connected extends React.Component {
    render () {
      return (
        <Consumer>
          {({ dispatch, _meta, ...rest }) => (
            <Comp {...subscriber(rest, this.props)} {...this.props} dispatch={dispatch} />
          )}
        </Consumer>
      )
    }
  }
  hoistNonReactStatics(Connected, Comp)
  return Connected
}
