import React from 'react'
import hoistNonReactStatics from 'hoist-non-react-statics'

const Context = React.createContext({})
export default Context

export const HoverContext = React.createContext({})

const ConsumerToComponent = Comp => subscriber => ({ dispatch, _meta, ...rest }) => (
  <Comp {...subscriber(rest, this.props)} {...this.props} dispatch={dispatch} />
)

export const Connect = subscribe => Comp => {
  const subscriber = typeof subscribe({}) === 'function' ? subscribe() : subscribe
  class Connected extends React.Component {
    render () {
      return <Context.Consumer>{ConsumerToComponent(Comp)(subscriber)}</Context.Consumer>
    }
  }
  hoistNonReactStatics(Connected, Comp)
  return Connected
}

export const ConnectHover = subscribe => Comp => {
  const subscriber = typeof subscribe({}) === 'function' ? subscribe() : subscribe
  class Connected extends React.Component {
    render () {
      return <HoverContext.Consumer>{ConsumerToComponent(Comp)(subscriber)}</HoverContext.Consumer>
    }
  }
  hoistNonReactStatics(Connected, Comp)
  return Connected
}
