import React from 'react'
import hoistNonReactStatics from 'hoist-non-react-statics'

const Context = React.createContext({})
const HoverContext = React.createContext({})

export const ChartProvider = Context.Provider
export const HoverProvider = HoverContext.Provider

const Connect = (subscribe => Comp => {
  const subscriber = typeof subscribe({}) === 'function' ? subscribe() : subscribe
  class Connected extends React.Component {
    render () {
      return (
        <Context.Consumer>
          {({ dispatch, _meta, ...rest }) => (
            <Comp {...subscriber(rest, this.props)} {...this.props} dispatch={dispatch} />
          )}
        </Context.Consumer>
      )
    }
  }
  hoistNonReactStatics(Connected, Comp)
  return Connected
}

export const ChartConnect = Connect(Context.Consumer)
export const HoverConnect = Connect(HoverContext.Consumer)