import React from 'react'
import hoistNonReactStatics from 'hoist-non-react-statics'

const ChartContext = React.createContext({})
const HoverContext = React.createContext({})

export const ChartProvider = ChartContext.Provider
export const HoverProvider = HoverChartContext.Provider

const Connect = (subscribe => Comp => {
  const subscriber = typeof subscribe({}) === 'function' ? subscribe() : subscribe
  class Connected extends React.Component {
    render () {
      return (
        <ChartContext.Consumer>
          {({ dispatch, _meta, ...rest }) => (
            <Comp {...subscriber(rest, this.props)} {...this.props} dispatch={dispatch} />
          )}
        </ChartContext.Consumer>
      )
    }
  }
  hoistNonReactStatics(Connected, Comp)
  return Connected
}

export const ChartConnect = Connect(ChartContext.Consumer)
export const HoverConnect = Connect(HoverChartContext.Consumer)