import React from 'react'
import hoistNonReactStatics from 'hoist-non-react-statics'

const ChartContext = React.createContext(null)
const PointerContext = React.createContext(null)

export const ChartProvider = ChartContext.Provider
export const PointerProvider = PointerContext.Provider

const Connect = Consumer => subscribe => Comp => {
  const subscriber = typeof subscribe({}) === 'function' ? subscribe() : subscribe
  class Connected extends React.Component {
    render () {
      return (
        <Consumer>
          {({ dispatch, _meta, ...rest }) => (
            <Comp {...subscriber(rest, this.props)} {...this.props} dispatch={dispatch} />
          )}
        </Consumer>
      )
    }
  }
  hoistNonReactStatics(Connected, Comp)
  return Connected
}

export const ChartConnect = Connect(ChartContext.Consumer)
export const PointerConnect = Connect(PointerContext.Consumer)
